<script lang="ts">
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
import type {
  Unit, Onset, Pixel, Point,
} from '@/data';
import type { ScrollTo } from '@/logic/ScrollActions';
import LabelBehavior from '../LabelBehavior.vue';

/**
 * Scrolls the canvas to a given onset on canvas creation
 */
@Component
export default class BScrollOnLoad extends LabelBehavior {
  mounted() {
    if (this.startOnset !== null) {
      this.scrollTo({
        x: this.pixelUnit.fromOnset(this.startOnset).value,
        y: 0,
      } as Point, false);
    }
  }

  @Prop({ default: null })
  startOnset!: Onset | null;

  @Prop()
  pixelUnit!: Unit<Pixel>;

  @Prop()
  scrollTo!: ScrollTo;
}
</script>
